/**
 */
package org.example.democatalog.impl;

import de.hftstuttgart.cityunits.model.NullableQuantity;
import de.hftstuttgart.cityunits.model.quantities.QuantitiesFactory;
import de.hftstuttgart.cityunits.model.quantities.QuantitiesPackage;
import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.example.democatalog.DemocatalogPackage;
import org.example.democatalog.Inverter;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Inverter</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link org.example.democatalog.impl.InverterImpl#getMaxDCVoltage <em>Max DC Voltage</em>}</li>
 *   <li>{@link org.example.democatalog.impl.InverterImpl#getMacDCCurrent <em>Mac DC Current</em>}</li>
 * </ul>
 *
 * @generated
 */
public class InverterImpl extends ElectricalDeviceImpl implements Inverter {
	/**
	 * The default value of the '{@link #getMaxDCVoltage() <em>Max DC Voltage</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMaxDCVoltage()
	 * @generated
	 * @ordered
	 */
	protected static final NullableQuantity MAX_DC_VOLTAGE_EDEFAULT = (NullableQuantity) QuantitiesFactory.eINSTANCE
			.createFromString(QuantitiesPackage.eINSTANCE.getQuantityDouble(), "0.0 V");

	/**
	 * The cached value of the '{@link #getMaxDCVoltage() <em>Max DC Voltage</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMaxDCVoltage()
	 * @generated
	 * @ordered
	 */
	protected NullableQuantity maxDCVoltage = MAX_DC_VOLTAGE_EDEFAULT;

	/**
	 * The default value of the '{@link #getMacDCCurrent() <em>Mac DC Current</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMacDCCurrent()
	 * @generated
	 * @ordered
	 */
	protected static final NullableQuantity MAC_DC_CURRENT_EDEFAULT = (NullableQuantity) QuantitiesFactory.eINSTANCE
			.createFromString(QuantitiesPackage.eINSTANCE.getQuantityDouble(), "100.0 mV");

	/**
	 * The cached value of the '{@link #getMacDCCurrent() <em>Mac DC Current</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMacDCCurrent()
	 * @generated
	 * @ordered
	 */
	protected NullableQuantity macDCCurrent = MAC_DC_CURRENT_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected InverterImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return DemocatalogPackage.Literals.INVERTER;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NullableQuantity getMaxDCVoltage() {
		return maxDCVoltage;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setMaxDCVoltage(NullableQuantity newMaxDCVoltage) {
		NullableQuantity oldMaxDCVoltage = maxDCVoltage;
		maxDCVoltage = newMaxDCVoltage;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, DemocatalogPackage.INVERTER__MAX_DC_VOLTAGE,
					oldMaxDCVoltage, maxDCVoltage));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NullableQuantity getMacDCCurrent() {
		return macDCCurrent;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setMacDCCurrent(NullableQuantity newMacDCCurrent) {
		NullableQuantity oldMacDCCurrent = macDCCurrent;
		macDCCurrent = newMacDCCurrent;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, DemocatalogPackage.INVERTER__MAC_DC_CURRENT,
					oldMacDCCurrent, macDCCurrent));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
		case DemocatalogPackage.INVERTER__MAX_DC_VOLTAGE:
			return getMaxDCVoltage();
		case DemocatalogPackage.INVERTER__MAC_DC_CURRENT:
			return getMacDCCurrent();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
		case DemocatalogPackage.INVERTER__MAX_DC_VOLTAGE:
			setMaxDCVoltage((NullableQuantity) newValue);
			return;
		case DemocatalogPackage.INVERTER__MAC_DC_CURRENT:
			setMacDCCurrent((NullableQuantity) newValue);
			return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
		case DemocatalogPackage.INVERTER__MAX_DC_VOLTAGE:
			setMaxDCVoltage(MAX_DC_VOLTAGE_EDEFAULT);
			return;
		case DemocatalogPackage.INVERTER__MAC_DC_CURRENT:
			setMacDCCurrent(MAC_DC_CURRENT_EDEFAULT);
			return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
		case DemocatalogPackage.INVERTER__MAX_DC_VOLTAGE:
			return MAX_DC_VOLTAGE_EDEFAULT == null ? maxDCVoltage != null
					: !MAX_DC_VOLTAGE_EDEFAULT.equals(maxDCVoltage);
		case DemocatalogPackage.INVERTER__MAC_DC_CURRENT:
			return MAC_DC_CURRENT_EDEFAULT == null ? macDCCurrent != null
					: !MAC_DC_CURRENT_EDEFAULT.equals(macDCCurrent);
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy())
			return super.toString();

		StringBuilder result = new StringBuilder(super.toString());
		result.append(" (maxDCVoltage: ");
		result.append(maxDCVoltage);
		result.append(", macDCCurrent: ");
		result.append(macDCCurrent);
		result.append(')');
		return result.toString();
	}

} //InverterImpl
